/*
 * Generated by veritool: Copyright (c) 2009-2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 */

`timescale 1 ns/1 ps

module testbench();

    parameter HALF_CYCLE_DELAY = 5;
    parameter RESET_CYCLE_NUMBER = 3;
    parameter INC_CYCLE_ACCORD_TO_FRONT_OF_CLK = 1;

    reg CE_RD;
    reg CE_RD_reg;
    reg CE_WR0;
    reg CE_WR0_reg;
    reg CE_WR1;
    reg CE_WR1_reg;
    reg CLK;
    reg [7:0] DI0;
    reg [7:0] DI0_reg;
    reg [7:0] DI1;
    reg [7:0] DI1_reg;
    reg RST;
    reg run;
    wire [7:0] DO;
    wire DO_VAL;
    wire IS_EMPTY0;
    wire IS_EMPTY1;
    wire IS_FULL0;
    wire IS_FULL1;

    always @(posedge CLK) begin
        CE_RD_reg <= CE_RD;
        CE_WR0_reg <= CE_WR0;
        CE_WR1_reg <= CE_WR1;
        DI0_reg <= DI0;
        DI1_reg <= DI1;
    end

    myfifo3parts target (
        .CE_RD(CE_RD_reg),
        .CE_WR0(CE_WR0_reg),
        .CE_WR1(CE_WR1_reg),
        .CLK(CLK),
        .DI0(DI0_reg),
        .DI1(DI1_reg),
        .RST(RST),
        .DO(DO),
        .DO_VAL(DO_VAL),
        .IS_EMPTY0(IS_EMPTY0),
        .IS_EMPTY1(IS_EMPTY1),
        .IS_FULL0(IS_FULL0),
        .IS_FULL1(IS_FULL1)
    );

    reg [63 : 0] CYCLE;
    reg [256 * 8 : 1] argv;
    reg [64 * 8 : 1] pstring;
    reg [64 * 8 : 1] dumpfilename;
    reg netscen;

    task cycle;
    input inc_CYCLE;
    begin
        CLK = 0; #(HALF_CYCLE_DELAY);
        if(inc_CYCLE == 1 && INC_CYCLE_ACCORD_TO_FRONT_OF_CLK == 1) CYCLE = CYCLE + 1;
        CLK = 1; #(HALF_CYCLE_DELAY);
        if(inc_CYCLE == 1 && INC_CYCLE_ACCORD_TO_FRONT_OF_CLK == 0) CYCLE = CYCLE + 1;
    end
    endtask

    task delay;
    input inc_CYCLE;
    input [31:0] number_of_cycles;
    reg [31:0] i;
    begin
        i = 0;
        while(i < number_of_cycles)
        begin
            cycle(inc_CYCLE);
            i = i + 1;
        end
    end
    endtask

    initial begin
        if(!$value$plusargs("dumpfile=%s", dumpfilename)) begin
            dumpfilename="testbench.vcd";
        end
        if(!$test$plusargs("nodumpfile")) begin
            $dumpfile(dumpfilename);
            $dumpvars(1, testbench);
        end
        CE_RD = 1'h0;
        CE_WR0 = 1'h0;
        CE_WR1 = 1'h0;
        CLK = 1'h0;
        DI0 = 8'h00;
        DI1 = 8'h00;
        RST = 1'h0;
        CYCLE = 0;
        RST = 1'h0;
        delay(0, RESET_CYCLE_NUMBER);

        RST = 1'h1;

        if($test$plusargs("netscen"))
            netscen = 1;
        else
            netscen = 0;

        argv = 0;
        if($value$plusargs("argv=%s", argv)) begin
        end

        if($value$plusargs("scen=%s", pstring)) begin
            $setScenario(netscen, argv, pstring);
            run = 1'h1;
        end
        else begin
            $display("Please, type a scenario name with +scen=SCEN_NAME parameter");
            run = 1'h0;
        end

        while(run) begin
            $applyAction();
            cycle(1);
            $checkAction();
        end
        cycle(1);
    end
endmodule

