/*
 * Copyright 2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* 
 * File: aspect_error.h
 * Description: 
 *       This file contains implementation of Aspectrace aspect "error".
 */

#include "aspect_error.h"
#include "aspectrace_internals.h"

static const char ASPECT[] = "error";


void aspect_error_traceFailure(const char *aspect, const char *shortDesc, const char *fullDesc)
{
const char *attrs[] = { "aspect", aspect, NULL };

	if (!aspectrace_allowed(ASPECT, "failure"))
		return;

	aspect_trace("error", NULL,
		create_TraceNode(
			"failure",
			attrs,
			create_TraceNode("short-desc", NULL, create_textTraceNode(shortDesc), NULL),
			create_TraceNode("description", NULL, create_textTraceNode(fullDesc), NULL),
			NULL
		)
	);
}
