/*
 * Copyright 2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <utils/parparser.h>
#include <utils/testreg.h>

static TestScenario *local_initTestScenario;
static TestScenario *local_testScenario;
static TestEngine *local_testEngine;
static int local_argc;
static char **local_argv;
static int local_netscen;

//extern start_scenario_with_wrapper(void(*wrapper)(void));

void set_scenario_wrapper(TestScenario *testScenario, TestEngine *testEngine, char *parameters, bool netscen)
{
    local_testScenario = testScenario;
    local_testEngine = testEngine;
    local_netscen = netscen;
    local_argc = parse_parameters(parameters, local_testScenario->name, &local_argv);
}

void set_scenario_wrapper_with_init(TestScenario *initTestScenario, TestScenario *testScenario, TestEngine *testEngine, char *parameters, bool netscen)
{
    local_initTestScenario = initTestScenario;
    set_scenario_wrapper(testScenario, testEngine, parameters, netscen);
}

void scenario_wrapper(void)
{
    if(!local_netscen)
        localmain(local_testEngine, local_testScenario, local_argc, local_argv);
    else
        netmain(local_testEngine, local_testScenario, local_argc, local_argv);
}

void scenario_wrapper_with_init(void)
{
    localmain(local_testEngine, local_initTestScenario, local_argc, local_argv);
    scenario_wrapper();
}

/*
int start_scenario(TestScenario *scen, char *params)
{
    set_scenario_wrapper(scen, &TE_NDFSM, params, 0);
    return start_scenario_with_wrapper(scenario_wrapper);
}

int start_net_scenario(TestScenario *scen, char *params)
{
    set_scenario_wrapper(scen, &TE_NDFSM, params, 1);
    return start_scenario_with_wrapper(scenario_wrapper);
}

int start_scenario_with_init(TestScenario *initscen, TestScenario *scen, char *params)
{
    set_scenario_wrapper_with_init(initscen, scen, &TE_NDFSM, params, 0);
    return start_scenario_with_wrapper(scenario_wrapper_with_init);
}

int start_net_scenario_with_init(TestScenario *initscen, TestScenario *scen, char *params)
{
    set_scenario_wrapper_with_init(initscen, scen, &TE_NDFSM, params, 1);
    return start_scenario_with_wrapper(scenario_wrapper_with_init);
}

int start_scenario_new(TestScenario *scen, TestEngine *testEngine, char *params, bool netscen)
{
    set_scenario_wrapper(scen, testEngine, params, netscen);
    return start_scenario_with_wrapper(scenario_wrapper);
}

int start_scenario_new_with_init(TestScenario *initscen, TestScenario *scen, TestEngine *testEngine, char *params, bool netscen)
{
    set_scenario_wrapper_with_init(initscen, scen, testEngine, params, netscen);
    return start_scenario_with_wrapper(scenario_wrapper_with_init);
}
*/

